#! /bin/sh

PRGM=/usr/local/phylogeny/phyml/bin/phyml-aa.sh
PRGM=`pwd`/phyml-aa.sh
FINALPARAMS="/usr/local/phylogeny/phyml/bin//pick_final_results.rb -p"

FNAME=Kunitz_BPTI_BPT1_BOVIN_39-91.2286.bl0_001
PRT=$FNAME.phy
TREE=$FNAME.newick
LOG=$FNAME.log

PARAMS=""
OPT_PARAMS=""

OPT_PARAMS="--print_site_lnl -on -ol"
OPT_PARAMS="--print_site_lnl --gamma_uneven"
OPT_PARAMS="--gamma_unequal 11204"
OPT_PARAMS="--scale_param 0.1 --scale_param e"
OPT_PARAMS="--rate_var_over_sites"

OPT_PARAMS="--print_site_lnl"
OPT_PARAMS="--pvar_b 0.01 --pvar_b e --print_site_lnl --print_post_mean_at_branch"
OPT_PARAMS="-c 4,3 --alpha e,e --print_site_lnl --print_post_mean_at_branch"

MODELS="LG-ML91+-12-e-F-dG4r WAG-ML91+-12-e-F-dG4r JTT-ML91+-12-e-F-dG4r KHG-ML200-12-e-F-dG4r EI-12-e-F-dG4r No-Constraint-11-e-F-dG4r No-Constraint-10-e-F-dG4r KHG-2-F-dG4r"
MODELS="WAG-1-F-dG4s JTT-1-F-dG4s LG-ML91+-4-e-F-dG4s WAG-ML91+-4-e-F-dG4s JTT-ML91+-4-e-F-dG4s KHG-ML200-4-e-F-dG4s"
MODELS="LG-1-F-dG9r"
MODELS="LG-1-F-dG4r"
MODELS="LG-F-dG4.3r"
MODELS="LG-1-F-dG4s-dG4r"
MODELS="LG-ML91+-4-e-F-dG4s-dG4r"
MODELS="LG-1-F-dG4r LG-1-F-dG4s"
MODELS="KHG-1-F-dG4r WAG-1-F-dG4r JTT-1-F-dG4r"
MODELS="LG-ML91+-11-e-F-dG4s KHG-ML200-11-e-F-dG4s WAG-ML91+-11-e-F-dG4s JTT-ML91+-11-e-F-dG4s"
MODELS="KHG-1-F-dG4s"
MODELS="LG-ML91+-11-e-F-dG4s-dG4r"
MODELS="LG-ML91+-11-e-F-dG4r"
MODELS="LG-ML91+-11-e-F-dG4s"
MODELS="LG-F-dG4r"

OPT_PARAMS="--print_site_lnl  --print_post_mean_at_branch -o n"
OPT_PARAMS="--print_site_lnl  --print_post_mean_at_branch -o n -o l"
OPT_PARAMS="--print_site_lnl  --print_post_mean_at_branch -o n -o tl"
#OPT_PARAMS="--alpha_w e $OPT_PARAMS"

for t in tree #tree_pvar_b
do
{
  if [ ! -d $t ] ; then
	mkdir $t
	ln -s ../$PRT $t/$PRT
	#ln -s ../.phy/$t.newick $t/$TREE
	ln -s ../$TREE $t/$TREE
  fi
  cd $t

  for model in $MODELS
  do

    negative_w0=`echo $model | sed 's/^khg-\([0-9]\)/KHG-\1/'`
    D=$negative_w0

    if [ ! -d $model ] ; then
	mkdir $model
	ln -s ../$PRT $model/$PRT
	ln -s ../$TREE $model/$TREE
    else
exit
	cp -ax $model $model.1
        D=$model.1
    fi

#D=../.d/tree/$model
#D=../tree/$model
D="LG-1-F-dG4s"
#D=`echo $model | sed 's/-dG.r//'`
#D="LG-ML91+-11-e-F-dG4s"
D="LG-1-F-dG4r"
D=`echo $model | sed 's/-11-/-4-/'`
D=../../seed/tree/$model
D=../../Kunitz_BPTI_BPT1_BOVIN_39-91.1721.bl0_05/tree_olr/$model
#FNAME=Kunitz_BPTI_BPT1_BOVIN_39-91.1721.bl0_05
D=$model.from_olr.ol
FNAME=Kunitz_BPTI.seed
D=../../seed/tree/$model

        if [ -s $D/${FNAME}.phy_phyml_tree.txt ] ; then
          #rm -f $model/$TREE
          #ln -s ../$D/${FNAME}.phy_phyml_tree.txt $model/$TREE
          PARAMS="`$FINALPARAMS $D/${FNAME}.phy_phyml_stats.txt` --alpha e --alpha_w e"
	  #PARAMS=""
        else
          #rm -f $model/$TREE
          #ln -s ../$D/$TREE $model/$TREE
	  PARAMS=""
        fi
        #PARAMS="`$FINALPARAMS $D/${FNAME}.phy_phyml_stats.txt` -a e"

	#w0=`echo "$PARAMS" | sed 's/^.*--mechanistic_params "0.000000 \([^ ]*\) .*$/\1/'` 
	#new_w0=`echo "$w0 - 1.61797318315582" | irb | tail -1`
	#PARAMS=`echo "$PARAMS" | sed 's/--mechanistic_params "0.000000 '$w0' /--mechanistic_params "0.000000 '$new_w0' /'` 


    cd $model
model=`echo $model | sed 's/\.[1-4]r/r/g'`

    echo "Executing $t/$model ..." 1>&2
    $PRGM $model $PRT $TREE $PARAMS $OPT_PARAMS 1> $LOG 2>&1
#echo $PRGM $model $PRT $TREE $PARAMS $OPT_PARAMS
#exit

    cd ..
  done

  cd ..
}
done


