#! /usr/local/bin/ruby

# pick a subtree from a large tree, which includes the specified number of sequences.

require 'set'

require "LIB/Phylogeny"
include Phylogeny

	class Tree
          def n_otus_closely_related_to_a_specific_otu(otu, n_seqs, exclude_tree)
                   
                tree = self
             
                distances_to_leaves = tree.distances_from_a_specific_otu(otu)

                (n_seqs...distances_to_leaves.size).each do |i|
			exclude = exclude_tree.search_leaf_by_node_info(distances_to_leaves[i][0].node_info[0])
			if exclude.nil?
                        	distances_to_leaves[i][0].parent_node.delete_linked_subtree(distances_to_leaves[i][0])
			end
                end  
                
                return tree
          end
	end


	cchar = '#'

	otu = ARGV[0].to_s
	n_seqs = ARGV[1].to_i

	tree_file = ARGV[2].to_s
	tree_port = File.open(tree_file)

	tree_str = get_tree_str_from_file(tree_port, "#")
	tree = make_tree_from_newick_str(tree_str)
	printf $stderr, "#otu = %d in the tree\n", tree.all_leaf_nodes.size

	nodes_removed = tree.rm_unnecessary_nodes
	if ! nodes_removed.nil?
		printf $stderr, "The %d unnecessary nodes were removed.\n", nodes_removed.size
	end

	exclude_tree_file = ARGV[3].to_s
	exclude_tree_port = File.open(exclude_tree_file)
	exclude_tree_str = get_tree_str_from_file(exclude_tree_port, "#")
	exclude_tree = make_tree_from_newick_str(exclude_tree_str)
	printf $stderr, "#otu = %d in the excluded tree\n", exclude_tree.all_leaf_nodes.size


	tree.dist_distr_from_a_specific_otu(otu, $stderr, 200)

	#root = tree.pick_n_otus_around_a_specific_otu(n_seqs, otu) 
	root = tree.n_otus_closely_related_to_a_specific_otu(otu, n_seqs - 1, exclude_tree)

	if root.nil?
		printf $stderr , "No such a subtree\n"
	else
		printf $stderr, "becomes #otu = %d\n", root.all_leaf_nodes.size
		print_tree_in_newick(tree, "",  " ")
	end
	



