#! /usr/local/bin/ruby

# pick a subtree from a large tree by removing nodes linked with shorter branch than the specified threshold.

require "LIB/Phylogeny"
include Phylogeny

	bl_threshold = ARGV[0].to_f

	#if ARGV.size > 1 
		newickfile = ARGV[1].to_s
		port_full = File.open(newickfile)
		newickfile = ARGV[2].to_s
		port_seed = File.open(newickfile)
	#else 
	#	port = $stdin
	#end
	ots_to_be_included = ARGV[3].to_s

	full_str = get_tree_str_from_file(port_full, "#")
	full_tree = make_tree_from_newick_str(full_str)
	printf $stderr, "#otu = %d\n", full_tree.all_leaf_nodes.size
	seed_str = get_tree_str_from_file(port_seed, "#")
	seed_tree = make_tree_from_newick_str(seed_str)

	#otu = seed_tree.all_leaf_nodes

	nodes_removed = full_tree.rm_unnecessary_nodes
	if ! nodes_removed.nil?
		printf $stderr, "The %d unnecessary nodes were removed.\n", nodes_removed.size
	end

	nodes_deleted = true
      until nodes_deleted.nil? do 
	parents_of_otu = full_tree.all_parents_of_leaves

	nodes_deleted = nil
	parents_of_otu.each do |p|
	  p_linked_nodes = p.linked_nodes
	  p_linked_nodes.each do |s|
	     if s.linked_nodes.size == 0
		len = s.node_info[1].to_f
		next if len > bl_threshold 
		if seed_tree.search_node_by_node_info(s.node_info[0]).nil? and s.node_info[0] != ots_to_be_included
		  	p_linked_nodes.each do |s2|
			    if s2.linked_nodes.size == 0
				len2 = s2.node_info[1].to_f
				if len > len2
					if seed_tree.search_node_by_node_info(s2.node_info[0]).nil? and s2.node_info[0] != ots_to_be_included
						s = s2
						len = len2
						break
					end
				end
			    end
		  	end
			full_tree.delete_linked_subtree(s)
			nodes_deleted = true
			break
		end
	     end
	  end
	end
     end

	# remove any info such as bootstrap probabilities
	#full_tree.all_parent_nodes.each do |p|
	#	p.node_info[0] = ""
	#end

	nodes_removed = full_tree.rm_unnecessary_nodes
	if ! nodes_removed.nil?
		printf $stderr, "The %d unnecessary nodes were removed.\n", nodes_removed.size
	end

	print_tree_in_newick(full_tree, "",  " ")

	printf $stderr, "becomes #otu = %d\n", full_tree.all_leaf_nodes.size

