
def assess_discore(nc_array, residue_pair_mi_di, residue_pairs, contact_pairs, n_residues)

   def assess_score(residue_pairs, contact_pairs, residue_pair_score, nc_array, residue_pair_mi_di)

     residue_pair_score = residue_pair_score.sort { |x, y|  y[2].abs <=> x[2].abs }

     scores = []
     i_nc = 0
     nc = nc_array[i_nc]
     tp = 0 
     fn = nil
     fp = 0 
     tn = nil

     co_tp = 0 
     co_fn = nil
     co_fp = 0 
     co_tn = nil
     distance = 0.0
     total_dist = nil
     min_dist_for_each_contact = nil
     (0...residue_pair_score.size).each do |i_pair|
		i, j, score = residue_pair_score[i_pair]

		#if ! residue_pair_mi_di[i].nil? and ! residue_pair_mi_di[i][j].nil? 
		#	if residue_pair_mi_di[i][j][0].is_a?(Array)
		#		next if residue_pair_mi_di[i][j][0][3] > 0 #or residue_pair_mi_di[i][j][0][4] > 0 #or residue_pair_mi_di[i][j][0][5] > 0 
		#	end
		#end

		if pair_included?(contact_pairs, i, j)
			tp = tp + 1
			co_tp = co_tp + (i - j).abs
			distance = distance + 
				distance_to_nearest_true_contact(i, j, contact_pairs)[0]
			total_dist, min_dist_for_each_contact = 
				coverage_of_contact_map(total_dist, min_dist_for_each_contact, i, j, contact_pairs)
		elsif pair_included?(residue_pairs, i, j) 
			fp = fp + 1
			co_fp = co_fp + (i - j).abs
			distance = distance + 
				distance_to_nearest_true_contact(i, j, contact_pairs)[0]
			total_dist, min_dist_for_each_contact = 
				coverage_of_contact_map(total_dist, min_dist_for_each_contact, i, j, contact_pairs)
		end

       if tp + fp == nc
         #scores[i_nc] = [tp, fn, fp, tn]
         scores[i_nc] = [tp, fn, fp, tn, co_tp, co_fn, co_fp, co_tn, distance, total_dist.dup ]
         i_nc = i_nc + 1

         break if i_nc >= nc_array.size

         nc = nc_array[i_nc]
       end

     end

     return scores
   end

   n_residue_pairs = n_residues * (n_residues - 1) / 2

   #n_residue_pairs, n_bonds, n_contacts, residue_pairs, bonded_residue_pairs, contact_pairs =
   #	 contact_residue_pairs(used_region, residue_pair_distance, contact_distance, min_res_num, max_res_num, residue_pair_mi_di)

   residue_pair_mi_di_array = []
   (0...residue_pair_mi_di.size).each do |r1|
     v = residue_pair_mi_di[r1]
     next if v.nil?
     (r1 + 1...v.size).each do |r2|
        mi_di = v[r2]
	next if mi_di.nil?
	residue_pair_mi_di_array = residue_pair_mi_di_array + [ [r1, r2, mi_di[0], mi_di[1]] ]
     end
   end

   residue_pair_score = []
   (0...residue_pair_mi_di_array.size).each do |i|
     residue_pair_score[i] = [ residue_pair_mi_di_array[i][0],  residue_pair_mi_di_array[i][1],  residue_pair_mi_di_array[i][3] ]
   end
   di_scores = assess_score(residue_pairs, contact_pairs, residue_pair_score, nc_array, residue_pair_mi_di)

   return di_scores

end
