#! /usr/local/bin/ruby 
#! /usr/local/bin/ruby -w

# multiple filters are used for both predictions.

#require 'Bio'
require "Utils/is_comment.rb"
require "Utils/Utils.rb"
include Utils

C_FOR_P_CATG = true
C_FOR_ALL_CATGS = true
BOTH_END_EXCLUDED = true

require "compare_ces_with_contacts.rb"

def main_corr

    opt = ''

    while true do
	i = 0;
	if ARGV[i] =~ /^--di/ then
		opt = opt + ARGV[i]
		ARGV.shift
	else
		break
	end
    end

	if (ARGV[0] =~ /^.*no.*del.*pos.*$/).nil? 
	# positions in the MSA that are included in the calculation of partial correlation coefficients
		prtseq = File.open(ARGV[0], "r")
        	used_positions = get_positions(prtseq)
		seq = get_seq(prtseq)
	# If this seq is included in the seed alignment, all sites are reliable and written in upper case.
		used_region = []
		(0...seq.size).each do |i| 
			if seq[i] == seq[i].upcase
				used_region[i] = 1	
			end
		end
		min_res_num = 1
		max_res_num = seq.size

        	use_positions = nil
	else	
	# If del positions in the MSA are included in the calculation of partial correlation coefficients
	# non_del positions are needed.
		prtseq = File.open(ARGV[0], "r")
        	use_positions = get_positions(prtseq)
		seq = get_seq(prtseq)
		used_region = []
		(0...seq.size).each do |i| 
			if seq[i] == seq[i].upcase
				used_region[i] = 1	
			end
		end
		min_res_num = 1
		max_res_num = seq.size
       	end
    pic = File.open(ARGV[1], "r") 

    rpad = File.open(ARGV[2], "r")

      if FLAG_DI_SCORE
        eic = File.open(ARGV[3], "r")

	residue_position_map_txt=ARGV[4]
	#residue_position_map_txt="Residue_position_map.txt"
	#if ARGV[2] =~ /\//
	#  residue_position_map_txt=ARG[2](/^(.*)\/[\/]*$/,\1) + "Residue_position_map.txt"
	#  residue_position_map = 
	#else
	  residue_position_map = File.open(residue_position_map_txt, "r")
	#end
	res_num_from = get_res_num_from(residue_position_map)

	mi_di =  File.open(ARGV[5], "r")
	port_ss_pred =  File.open(ARGV[6], "r") if DI_SEC_STRUCT_CLASH_FLAG or SEC_STRUCT_CLASH_FLAG
     end

    residue_pair_distance, min_res_num, max_res_num, = get_rpad(rpad)

    ss_predicted = get_ss_pred(port_ss_pred, res_num_from)	if DI_SEC_STRUCT_CLASH_FLAG or SEC_STRUCT_CLASH_FLAG

  if FLAG_DI_SCORE
    if opt == '--di'
      used_region, residue_pair_mi_di, = get_mi_di(eic, res_num_from)
    else
      #used_region, residue_pair_mi_di, = get_discore(eic, res_num_from)
      used_region, residue_pair_mi_di, = get_discore_with_filter_check(eic, res_num_from, ss_predicted)
      sec_struct_clash?(1, 1, ss_predicted, residue_pair_mi_di) if DI_SEC_STRUCT_CLASH_FLAG or SEC_STRUCT_CLASH_FLAG
      used_region, = get_mi_di(mi_di, res_num_from)
    end

    raise "Sequence Region is wrong.\n" 	if used_region.size > (max_res_num - min_res_num + 2)
  else
	residue_pair_mi_di = nil
	used_region = []
	(1..(max_res_num - min_res_num + 1)).each { |i| used_region[i] = 1 }
  end

    #n_residue_pairs = (max_res_num - min_res_num + 1) * (max_res_num - min_res_num) / 2
        
    printf "# Neighboring residue pairs (|i - j| <= %d) are excluded.\n", MAX_SEPARATION_ALONG_CHAIN_EXCLUDED

    n_residue_pairs, n_bonds, n_contacts, residue_pairs, bonded_residue_pairs, contact_pairs, contact_order =
        contact_residue_pairs(used_region, residue_pair_distance, CONTACT_DISTANCE, min_res_num, max_res_num, residue_pair_mi_di)

#(1..(max_res_num - min_res_num + 1)).each { used_region[i] = 1 }

    #n_residues = (max_res_num - min_res_num + 1)
    n_residues = 0
    (1...used_region.size).each { |i| n_residues = n_residues + 1 if ! used_region[i].nil? }

    if FLAG_3D_AVAILABLE
    	printf "# #residues = %d  #residue_pairs = %d  #contacts = %d\n", n_residues, n_residue_pairs, n_contacts
    else
    	printf "# #residues = %d  #residue_pairs = %d\n", n_residues, n_residue_pairs
    end
    
    n_residues_orig = n_residues
    n_contacts_orig = n_contacts

    #if (defined?(C_FOR_ALL_CATGS) and C_FOR_ALL_CATGS) or (defined?(C_FOR_P_CATG) and C_FOR_P_CATG)
    if (defined?(BOTH_END_EXCLUDED) and BOTH_END_EXCLUDED)
    # Exclude both terminals
      used_region[1] = nil
      used_region[-1] = nil
      printf "# Both terminal sites are excluded for analysis.\n"

      n_residue_pairs, n_bonds, n_contacts, residue_pairs, bonded_residue_pairs, contact_pairs, contact_order =
        contact_residue_pairs(used_region, residue_pair_distance, CONTACT_DISTANCE, min_res_num, max_res_num, residue_pair_mi_di)

#(1..(max_res_num - min_res_num + 1)).each { used_region[i] = 1 }

      #n_residues = (max_res_num - min_res_num + 1)
      n_residues = 0
      (1...used_region.size).each { |i| n_residues = n_residues + 1 if ! used_region[i].nil? }
     if FLAG_3D_AVAILABLE
      printf "# #residues = %d  #residue_pairs = %d  #contacts = %d\n", n_residues, n_residue_pairs, n_contacts
     else
      printf "# #residues = %d  #residue_pairs = %d\n", n_residues, n_residue_pairs
     end
    end

    nc_array = []
    min_nc = (n_residues_orig * 0.5).to_i
    min_nc = (n_contacts_orig * 0.25).to_i
    max_nc = n_residues_orig
    max_nc = (n_residues_orig * 0.75).to_i
    max_nc = (n_contacts_orig / 3.0).to_i
    max_nc = n_residues_orig                 if ! FLAG_3D_AVAILABLE
    nc = 10
    i = 0
    #while nc <= n_residues_orig * 1.0 or nc <= 50 do
    while nc <= [max_nc, n_residues_orig ].max
      nc_array[i] = nc
      i = i + 1
      if nc < min_nc and nc + 10 > min_nc
        nc_array[i] = min_nc
        i = i + 1
      end
      if nc < max_nc and nc + 10 > max_nc
        nc_array[i] = max_nc
        i = i + 1
      end
      if nc < n_residues_orig and nc + 10 > n_residues_orig
	if max_nc != n_residues_orig
          nc_array[i] = n_residues_orig
          i = i + 1
	end
      end
      nc = nc + 10
    end
    #nc_array = [ n_residues_orig ]

    first_block = true
 while true do
    n_otu, threshold, n_characters, residue_pair_c, residue_pair_info, change_sd = get_pc(pic, n_residue_pairs, use_positions, inc_order_of_ev = true)
    break if threshold.nil? 

    if defined?(C_FOR_ALL_CATGS) and C_FOR_ALL_CATGS
      ################## for corr. coeff. for all categories
      printf "#\n# Correlation coefficients instead of partial corr. coeff. are used for all categories.\n#\n"
      residue_pair_c = get_c(residue_pair_info)
    elsif defined?(C_FOR_P_CATG) and C_FOR_P_CATG
      ################## for partial corr. coeff. for catg 0 and corr. coeff. for others
      printf "#\n# Partial corr. coeff. are used only for category 0 and correlation coefficients are used for other categories.\n#\n"
      residue_pair_c = get_pc_for_catg0_and_c(residue_pair_info)
      ##################
    else
      printf "#\n# Partial corr. coeff. are used for all categories.\n#\n"
    end

    n_br = 2 * n_otu - 3		if ! n_otu.nil?

   if ! first_block 
     use_axes = USE_AXES
     printf "#axes used = " 
     p use_axes
   else
     use_axes = nil
   end

   lower_threshold, decreasing_order_of_n_subst_pc = calc_lower_threshold_array(residue_pairs, residue_pair_c, PRIORITY_CATG, n_residues, nc_array[-1])

#(0...lower_threshold.size).each {|i| lower_threshold[i] = lower_threshold[nc_array[-1]] }
#(0...lower_threshold.size/2).each {|i| lower_threshold[i] = lower_threshold[i * 2] }

   residue_pair_c_orig = residue_pair_c
   change_sd_threshold = (1.0 / Math.sqrt(n_br.to_f)) * 0.1		if ! n_otu.nil?

   residue_pair_c = filter_pc(residue_pair_c, PRIORITY_CATG, threshold, 0.0, change_sd, change_sd_threshold, residue_pairs, ! first_block)
   
   if FLAG_DI_SCORE
     di_scores = assess_discore(nc_array, residue_pair_mi_di, residue_pairs, contact_pairs, n_residues)
   end

   pic_scores =
      assess_pc_score(residue_pair_c, nc_array, PRIORITY_CATG, lower_threshold, threshold, residue_pairs, contact_pairs, n_residues, use_axes)

   scores_each_category, pc_cutoff = score_statics(nc_array, di_scores, pic_scores, contact_pairs, threshold)

   (0...scores_each_category.size).each do |i_method|
     next if USE_CORRELATION[i_method] > 1
     printf "#\n# Method = %d\n", i_method
     printf "# method #OTU ; TP FP PPV  L*N*CO L*CO  MDPNT MDTNP ... Corr E-val ...\n"

     #(0...scores_each_category[i_method].size - 1).each do |i_nc|
     (0...nc_array.size).each do |i_nc|
	printf "%d %d ;", i_method, n_otu
      if FLAG_DI_SCORE
	if i_nc < nc_array.size and ! di_scores[ i_nc ].nil?
        	printf " %d", nc_array[i_nc]
		printf " %.1f", (contact_order / n_contacts).to_f
	  if ! di_scores[ i_nc ].nil?
        	printf "  %d %d %.3f", di_scores[ i_nc ][0], di_scores[ i_nc ][2], di_scores[ i_nc ][0]/(di_scores[ i_nc ][0] + di_scores[ i_nc ][2]).to_f
		printf "  %d %.1f", di_scores[ i_nc ][4], di_scores[ i_nc ][4]/di_scores[ i_nc ][0].to_f
		printf "  %.2f", di_scores[ i_nc ][8]/(di_scores[ i_nc ][0] + di_scores[ i_nc ][2]).to_f
		printf "  %.2f", di_scores[ i_nc ][9][0]/(di_scores[ i_nc ][9][1]).to_f
	  else
		printf "\t" 
	  end
	else
		printf "\t" 
	end
	printf " ;"
      end
	scores = pic_scores[i_method][0][i_nc]
        printf " %d %d %.3f ", scores[0], scores[2], scores[0]/(scores[0] + scores[2]).to_f
	#printf "  %f ",	decreasing_order_of_n_subst_pc[nc_array[i_nc]]
        printf " %d %.1f ", scores[4], scores[4]/scores[0].to_f
	printf " %.2f ", scores[8] / (scores[0] + scores[2]).to_f
	printf " %.2f ", scores[9][0] / scores[9][1].to_f
	printf "  %f ",	scores[-1]
	#printf "  %f ",	pc_cutoff[i_method][i_nc]
	#n_c = (n_sites * (n_sites - 1 - 2 * MAX_SEPARATION_ALONG_CHAIN_EXCLUDED) + MAX_SEPARATION_ALONG_CHAIN_EXCLUDED * (MAX_SEPARATION_ALONG_CHAIN_EXCLUDED + 1) ) * 0.5
	n_c = n_residue_pairs
	printf " %.1e ", p_threshold(scores[-1], (n_br - 2)) * n_c
        (0...scores_each_category[i_method][i_nc].size).each do |i_catg|
		scores = scores_each_category[i_method][i_nc][i_catg]
        	printf " | %d %d", scores[0], scores[1] 
	end
	printf "\n"
     end
   end

   first_block = false

   break
 end

end #def main_corr

main_corr
