#! /bin/sh
#
# How to use this script.
# 0. PROJECT and PFAMID in this script must be properly defined; they are defined to run in Example.
# 1. compare_ces_with_contacts.pc.sh > compare_ces_with_contacts.out
# 2. print_ces_rank.sh > ces_rank
# 3. print_ces_pairs.sh 37 < ces_rank > ces_pairs37	# 37 should be replace by the number of contacts to be predicted
#

PRGM=`basename $0 .sh`

CWD=`pwd`

# PROJECT and PFAMID must be defined.
#PROJECT=`echo $CWD | sed -e 's/^\(.*\/12\.[^/]*\)\/.*$/\1/'`
#PFAMID=`echo $CWD | sed -e 's/^.*\/12\.[^/]*\///' -e 's/\/.*$//'`
PROJECT=`echo $CWD | sed -e 's/^\(.*\/Example[^/]*\)\/.*$/\1/'`
PFAMID=`echo $CWD | sed -e 's/^.*\/Example[^/]*\///' -e 's/\/.*$//'`


RUBYLIB=$RUBYLIB:$PROJECT/tools
export RUBYLIB

# The followings are used only if FLAG_DI_SCORE == true.
DIS=$PROJECT/$PFAMID/EIC/*DIScores.csv
MI_DI=$PROJECT/$PFAMID/EIC/*_MI_DI.csv
SS_STR=$PROJECT/$PFAMID/EIC/*_ss_pred.tbl
RES_MAP=$PROJECT/$PFAMID/EIC/Residue*map*
EIC_PAIR=$PROJECT/$PFAMID/EIC/*eic*pair*

# The followings are used only if FLAG_3D_AVAILABLE == true.
RPAD=$PROJECT/$PFAMID/PDB/*rpad
RPAD5=${RPAD}5

CES=$CWD/*branch*txt
CES_RANK=$CWD/*rank*txt
CES_PAIR=$CWD/*pic*txt
if [ -f $CWD/*non_del_pos* ] ; then
	# If del positions in the MSA are included in the calculation of partial correlation coefficients
        # non_del positions are needed.
	CES_POSITIONS=$CWD/*.non_del_pos+seq
else
	# positions in the MSA that are included in the calculation of partial correlation coefficients
	CES_POSITIONS=$CWD/*.non_del_seq
fi

RPAD_0=`echo $PRGM | sed -n 's/^[^-]*-//p' | tr 'a-z' 'A-Z'`
if [ -n $RPAD_0 ] ; then
	PRGM=`echo $PRGM | sed 's/-.*$//'`
	RPAD=$PROJECT/$PFAMID/PDB/${RPAD_0}*.rpad
else
	if [ -n "$1" ] ; then
		RPAD_0=`echo "$1" | tr 'a-z' 'A-Z'`
		RPAD=$PROJECT/$PFAMID/PDB/${RPAD_0}*.rpad
		shift
	fi
fi

eval $PROJECT/tools/$PRGM.rb "$CES_POSITIONS" "$CES" "$RPAD" "$DIS" "$RES_MAP" "$MI_DI" "$SS_STR" $*

