
def contact_residue_pairs(used_region, residue_pair_distance, contact_distance, min_res_num, max_res_num,  residue_pair_mi_di = nil)

   raise "Sequence Region is wrong.\n" 	if ! used_region and used_region.size > (max_res_num - min_res_num + 2) 

   contact_pairs = []
   residue_pairs = []
   bonded_residue_pairs = []
   n_residue_pairs = 0
   (0...used_region.size).each do |i|
     next if used_region[i].nil?
     (i + 1...used_region.size).each do |j|
       next if used_region[j].nil?
       next if (i - j).abs <= MAX_SEPARATION_ALONG_CHAIN_EXCLUDED

        if ! residue_pair_mi_di.nil? and ! residue_pair_mi_di[i].nil? and ! residue_pair_mi_di[i][j].nil?
                        if residue_pair_mi_di[i][j][0].is_a?(Array)
				# for comparison with EIC
				#sec_struct_clash_flag,high_conservation_flag,cys_cys_repartnering_flag
                                #if residue_pair_mi_di[i][j][0][3] > 0 or residue_pair_mi_di[i][j][0][4] > 0 or residue_pair_mi_di[i][j][0][5] > 0
                                if residue_pair_mi_di[i][j][0][3] > 0 #or residue_pair_mi_di[i][j][0][4] > 0 #or residue_pair_mi_di[i][j][0][5] > 0
                                        #next
                                end
                        end

        end

        n_residue_pairs = n_residue_pairs + 1
        if ! residue_pair_distance.nil?
	  residue_pairs[i] = [] if residue_pairs[i].nil?
	  residue_pairs[i][j]  = 99.0
	  residue_pairs[i][j]  = residue_pair_distance[i][j]  if ! residue_pair_distance[i].nil? and ! residue_pair_distance[i][j].nil?
   	  residue_pairs[j] = [] if residue_pairs[j].nil?
	  residue_pairs[j][i]  = 99.0
	  residue_pairs[j][i]  = residue_pair_distance[i][j]  if ! residue_pair_distance[i].nil? and ! residue_pair_distance[i][j].nil?
	else
	  residue_pairs[i] = [] if residue_pairs[i].nil?
	  residue_pairs[i][j]  = 0.0
   	  residue_pairs[j] = [] if residue_pairs[j].nil?
	  residue_pairs[j][i]  = 0.0
	end
     end
   end
   contact_order = 0
   n_contacts = 0
   n_bonds = 0
   #residue_pair_distance.each_key do |i|
   #	residue_pair_distance[i].each_key do |j|
   #(0...residue_pair_distance.size).each do |i|
   #	next if used_region[i].nil?
   #	next if residue_pair_distance[i].nil?
   # 	(i + 1...residue_pair_distance[i].size).each do |j|
   #		next if used_region[j].nil?
   #		next if (i - j).abs <= MAX_SEPARATION_ALONG_CHAIN_EXCLUDED
   #		next if residue_pair_distance[i][j].nil?
   (0..residue_pairs.size).each do |i| 
     next if residue_pairs[i].nil?
     (0...i).each do |j| 
       next if residue_pairs[i][j].nil?
		if residue_pairs[i][j] <= CHEMICAL_BOND_THRESHOLD  and (i - j).abs <= 1	#s-s bonds are exlcuded.
			n_bonds = n_bonds + 1
   			bonded_residue_pairs[i] = [] if bonded_residue_pairs[i].nil?
			bonded_residue_pairs[i][j]  = residue_pair_distance[i][j]
   			bonded_residue_pairs[j] = [] if bonded_residue_pairs[j].nil?
			bonded_residue_pairs[j][i]  = residue_pair_distance[i][j]
		elsif residue_pairs[i][j] <= contact_distance
			n_contacts = n_contacts + 1 
   			contact_pairs[i] = [] if contact_pairs[i].nil?
			contact_pairs[i][j]  = residue_pairs[i][j]	#residue_pair_distance[i][j]
   			contact_pairs[j] = [] if contact_pairs[j].nil?
			contact_pairs[j][i]  = residue_pairs[i][j]	#residue_pair_distance[i][j]
			contact_order = contact_order + (i - j).abs
		end
     end
   end

   return n_residue_pairs, n_bonds, n_contacts, residue_pairs, bonded_residue_pairs, contact_pairs, contact_order

end

def pair_included?(residue_pairs, i, j)
	#return false if residue_pairs[i].nil?
	#return false if residue_pairs[i][j].nil?
	#return true
	return true if ! residue_pairs[i].nil? and ! residue_pairs[i][j].nil?
	return true if ! residue_pairs[j].nil? and ! residue_pairs[j][i].nil?
	return false
end

def value_for_pair(residue_pairs, i, j)
	#return nil if residue_pairs[i].nil?
	#return nil if residue_pairs[i][j].nil?
	#return residue_pairs[i][j]
	return residue_pairs[i][j] if ! residue_pairs[i].nil? and ! residue_pairs[i][j].nil?
	return residue_pairs[j][i] if ! residue_pairs[j].nil? and ! residue_pairs[j][i].nil?
	return nil
end

def conv_pairs_from_hash_to_array(contact_pairs)

    contact_matrix = []
    contact_pairs.each do |i, v1|
        contact_matrix[i] = [] if contact_matrix[i].nil?
        next if contact_pairs[i].nil?
        contcat_pairs[i].each do |j, v2|
                #next if contact_pairs[i][j].nil?
                contact_matrix[i][j] = v2
                contact_matrix[j] = [] if contact_matrix[j].nil?
                contact_matrix[j][i] = v2
        end
    end

    return contact_matrix

end

