
def get_res_num_from(port)
	port.each_line("\n") do |i|
		i.chomp!
		next if is_comment?(i, '^#')
		items = i.split(/;/)
		from_to = items[0].split(/-/)
		return from_to[0].to_i, from_to[1].to_i
	end
	raise
end

def get_mi_di(port, res_num_from_to)
	residue_pair_mi_di = []
	used_region = []
	line_num = 0
	port.each_line("\n") do |line|
		line_num = line_num + 1
		next if line_num <= 1
		line.chomp!
		next if is_comment?(line, '^#')
		if line =~ /,/
			items = line.split(/,/)
		else
			items = line.split(/ /)
		end
		i = items[0].to_i - res_num_from_to[0] + 1
		j = items[2].to_i - res_num_from_to[0] + 1
		next if i <= 0 or j <= 0

		residue_pair_mi_di[i] = [] if residue_pair_mi_di[i].nil?
		residue_pair_mi_di[i][j] = [items[4].to_f, items[5].to_f]
		residue_pair_mi_di[j] = [] if residue_pair_mi_di[j].nil?
		residue_pair_mi_di[j][i] = [items[4].to_f, items[5].to_f]
		used_region[i] = 1
		used_region[j] = 1
	end
	used_region[res_num_from_to[1] - res_num_from_to[0] + 1] = nil	if used_region[res_num_from_to[1] - res_num_from_to[0] + 1].nil?
    return used_region, residue_pair_mi_di
end

if ! defined?(DI_SEC_STRUCT_CLASH_FLAG)
	DI_SEC_STRUCT_CLASH_FLAG = false
end
if ! defined?(DI_HIGH_CONSERVATION_FLAG)
	DI_HIGH_CONSERVATION_FLAG = true
end
if ! defined?(DI_CYS_CYS_REPARTNERING_FLAG)
	DI_CYS_CYS_REPARTNERING_FLAG = false
end

def get_discore_with_filter_check(port, res_num_from_to, ss_predicted = nil)
	residue_pair_mi_di = []
	used_region = []
	line_num = 0
	port.each_line("\n") do |line|
		line_num = line_num + 1
		next if line_num <= 1
		line.chomp!
		next if is_comment?(line, '^#')
		if line =~ /,/
		  items = line.split(/,/)
		else
		  items = line.split(/ /)
		end
		i = items[0].to_i - res_num_from_to[0] + 1
		j = items[1].to_i - res_num_from_to[0] + 1

		next if i <= 0 or j <= 0

		residue_pair_mi_di[i] = [] if residue_pair_mi_di[i].nil?
		residue_pair_mi_di[i][j] = [[items[3].to_f, items[4].to_f, items[5].to_f, items[6].to_i, items[7].to_i, items[8].to_i], items[2].to_f]

		residue_pair_mi_di[j] = [] if residue_pair_mi_di[j].nil?
		residue_pair_mi_di[j][i] = residue_pair_mi_di[i][j]

		#sec_struct_clash_flag,high_conservation_flag,cys_cys_repartnering_flag
		#residue_pair_mi_di[i][j][1] = 0.0 if residue_pair_mi_di[i][j][0][3] > 0 or residue_pair_mi_di[i][j][0][4] > 0 or residue_pair_mi_di[i][j][0][5] > 0
		#residue_pair_mi_di[i][j][1] = 0.0 if residue_pair_mi_di[i][j][0][4] > 0 or residue_pair_mi_di[i][j][0][5] > 0
		if DI_SEC_STRUCT_CLASH_FLAG 
		  if ss_predicted.nil?
		     residue_pair_mi_di[i][j][1] = 0.0 if residue_pair_mi_di[i][j][0][3] > 0
		  elsif ! ss_predicted.nil?
		    if residue_pair_mi_di[i][j][0][3] > 0
			printf $stderr, "Error on ss_filter: %d and %d to be clashed; corrected not to clash.\n", i, j if ! sec_struct_clash?(i, j, ss_predicted, residue_pair_mi_di)

		    else
			printf $stderr, "Error on ss_filter: %d and %d to be not clashed; corrected to clash.\n", i, j if sec_struct_clash?(i, j, ss_predicted, residue_pair_mi_di)
		    end
		    ########## corrected
		    residue_pair_mi_di[i][j][1] = 0.0 if sec_struct_clash?(i, j, ss_predicted, residue_pair_mi_di)
		  end
		end
		if DI_HIGH_CONSERVATION_FLAG 
		  residue_pair_mi_di[i][j][1] = 0.0 if residue_pair_mi_di[i][j][0][4] > 0
		end
		if DI_CYS_CYS_REPARTNERING_FLAG 
		  residue_pair_mi_di[i][j][1] = 0.0 if residue_pair_mi_di[i][j][0][5] > 0
		end

		used_region[i] = 1
		used_region[j] = 1

	end
	used_region[res_num_from_to[1] - res_num_from_to[0] + 1] = nil	if used_region[res_num_from_to[1] - res_num_from_to[0] + 1].nil?

    	return used_region, residue_pair_mi_di
end

def get_discore(port, res_num_from_to)
	residue_pair_mi_di = []
	used_region = []
	line_num = 0
	port.each_line("\n") do |line|
		line_num = line_num + 1
		next if line_num <= 1
		line.chomp!
		next if is_comment?(line, '^#')
		if line =~ /,/
		  items = line.split(/,/)
		else
		  items = line.split(/ /)
		end
		i = items[0].to_i - res_num_from_to[0] + 1
		j = items[1].to_i - res_num_from_to[0] + 1

		next if i <= 0 or j <= 0

		residue_pair_mi_di[i] = [] if residue_pair_mi_di[i].nil?
		residue_pair_mi_di[i][j] = [[items[3].to_f, items[4].to_f, items[5].to_f, items[6].to_i, items[7].to_i, items[8].to_i], items[2].to_f]

		#sec_struct_clash_flag,high_conservation_flag,cys_cys_repartnering_flag
		#residue_pair_mi_di[i][j][1] = 0.0 if residue_pair_mi_di[i][j][0][3] > 0 or residue_pair_mi_di[i][j][0][4] > 0 or residue_pair_mi_di[i][j][0][5] > 0
		#residue_pair_mi_di[i][j][1] = 0.0 if residue_pair_mi_di[i][j][0][4] > 0 or residue_pair_mi_di[i][j][0][5] > 0
		if DI_SEC_STRUCT_CLASH_FLAG 
		  residue_pair_mi_di[i][j][1] = 0.0 if residue_pair_mi_di[i][j][0][3] > 0
		end
		if DI_HIGH_CONSERVATION_FLAG 
		  residue_pair_mi_di[i][j][1] = 0.0 if residue_pair_mi_di[i][j][0][4] > 0
		end
		if DI_CYS_CYS_REPARTNERING_FLAG 
		  residue_pair_mi_di[i][j][1] = 0.0 if residue_pair_mi_di[i][j][0][5] > 0
		end

		residue_pair_mi_di[j] = [] if residue_pair_mi_di[j].nil?
		residue_pair_mi_di[j][i] = residue_pair_mi_di[i][j]

		used_region[i] = 1
		used_region[j] = 1

	end
	used_region[res_num_from_to[1] - res_num_from_to[0] + 1] = nil	if used_region[res_num_from_to[1] - res_num_from_to[0] + 1].nil?

    	return used_region, residue_pair_mi_di
end

##

def get_ss_pred(port, res_num_from_to)

	ss_struct = []
	line_num = 0
	port.each_line("\n") do |line|
		line_num = line_num + 1
		next if line_num <= 1
		line.chomp!
		next if is_comment?(line, '^#')
		if line =~ /\t/
		  items = line.split(/\t/)
		else
		  items = line.split(/ /)
		end
		i = items[0].to_i - res_num_from_to[0] + 1
		j = items[0].to_i - res_num_from_to[1]

		next if i <= 0

		# amino acid, ss pred
		ss_struct[i] = [ items[1], items[2] ]

		break if j >= 0
	end

	rev_ss_struct = []
	(1...ss_struct.size).each do |i|
		rev_ss_struct[i] = ss_struct[ss_struct.size - i]
	end

    	return ss_struct, rev_ss_struct
end


def sec_struct_clash?(i, j, ss_struct = nil, residue_pair_mi_di = nil)

#residue_pair_mi_di = nil

# global variable : $sec_struct_clash_pair is used only in this method.
# global variable : $sec_struct is used only in this method.

    if ! ss_struct.nil?
      $sec_struct = ss_struct 
    else
      ss_struct = $sec_struct if defined?($sec_struct)
    end

    if ! residue_pair_mi_di.nil?
	$sec_struct_clash_pair = [] if ! defined?($sec_struct_clash_pair)

	#if $sec_struct_clash_pair[i].nil? or $sec_struct_clash_pair[i][j].nil?
	  (1...residue_pair_mi_di.size).each do |ii|
	  #ii = i
	     $sec_struct_clash_pair[ii] = [] if $sec_struct_clash_pair[ii].nil?
	  end

	  (1...residue_pair_mi_di.size).each do |ii|
	    next if residue_pair_mi_di[ii].nil?
	    (1...ii).each do |jj|
	      next if jj.nil? or residue_pair_mi_di[ii][jj].nil?

	      next if ! $sec_struct_clash_pair[ii][jj].nil?

	  #(i..i).each do |ii|
	  # (j..j).each do |jj|

	      $sec_struct_clash_pair[jj] = [] if $sec_struct_clash_pair[jj].nil?
	      #error if residue_pair_mi_di[ii][jj].nil? or residue_pair_mi_di[ii][jj][0][3] <= 0
	      if residue_pair_mi_di[ii][jj][0][3] <= 0
		  $sec_struct_clash_pair[ii][jj] = false
		  $sec_struct_clash_pair[ii][jj] = 'c' if ii == jj
		  $sec_struct_clash_pair[jj][ii] = $sec_struct_clash_pair[ii][jj]
		  next
	      else
		#  (jj..ii).each do |kk|
		#    (jj..kk).each do |k|
		#	$sec_struct_clash_pair[kk][k] = 'c' if $sec_struct_clash_pair[kk][k].nil? or $sec_struct_clash_pair[kk][k] == 0
		#	$sec_struct_clash_pair[k] = [] if $sec_struct_clash_pair[k].nil?
		#	$sec_struct_clash_pair[k][kk] = $sec_struct_clash_pair[kk][k]
		#   end
		#  end

		  $sec_struct_clash_pair[ii][jj] = 'c'	#residue_pair_mi_di[ii][jj][0][3]
		  $sec_struct_clash_pair[jj][ii] = $sec_struct_clash_pair[ii][jj]
		  next
	      end
	    end
	  end
	#end
    end

    return 'c' if i == j

    if defined?($sec_struct_clash_pair) and ! $sec_struct_clash_pair.nil?
	if ! $sec_struct_clash_pair[i].nil? and ! $sec_struct_clash_pair[i][j].nil? 
	  if $sec_struct_clash_pair[i][j] == false
		return false
	  else
		#if $sec_struct_clash_pair[i][j] < 0
		#	printf $stderr, "%d %d\n", i, j
		#end
		return true
	  end
	end
    end

   	def helix_clash_0?(ss_struct, i, j) 

	  if i + 3 > j		#if i > j
		raise "Error\n"
	  end

	  for k in (i + 3)..(j - 1)
	 	return false if ss_struct[k][1] != 'H'
	  end

	  if ss_struct[j][1] != 'H'		
		if ss_struct[i][1] != 'H' and ss_struct[i + 1][1] == 'H' and ss_struct[i + 2][1] == 'H'
			 return true		# H-1 H H ... H+1
		end
		return false			# ... H+1
	  end
						#  vs H
	  if ss_struct[i][1] != 'H' or ss_struct[i+1][1] != 'H'  or ss_struct[i+2][1] != 'H'
	    if ss_struct[i+2][1] != 'H'
	      return true if j - (i + 3) + 1 >= 10	# H-3 vs H
	      return false
	    end
	    if ss_struct[i+1][1] != 'H' and ss_struct[i+2][1] == 'H'	# H-2 vs H
		return true if j - (i + 2) + 1 > 5
	        return false
	    end
	    if ss_struct[i][1] != 'H' and ss_struct[i+1][1] == 'H' and ss_struct[i+2][1] == 'H'
		return true			# H-1 vs H
	    end
	    raise 'Error \n' #return false
	  else
	    return true				# H vs H
	  end

	end

   	def helix_clash?(ss_struct, i, j) 

	  if i > j
	    k = i
	    i = j
	    j = k
	  end
	  clash = helix_clash_0?(ss_struct[0], i, j) 
	  return clash if clash 
	  return helix_clash_0?(ss_struct[1], ss_struct[0].size - j, ss_struct[0].size - i)
	  #return false
	end

   	def beta_clash_0?(ss_struct, i, j) 

	  if i + 5 > j		#if i > j
		raise "Error\n"
	  end

	  for k in (i + 4)..(j - 2)
	 	return false if ss_struct[k][1] != 'E'
	  end

	  if  ss_struct[j - 1][1] != 'E' or ss_struct[j][1] != 'E'	
	      if  ss_struct[j - 1][1] == 'E'		#     vs  E+1
		if ss_struct[i][1] != 'E' and ss_struct[i + 1][1] == 'E' and ss_struct[i + 2][1] == 'E' and ss_struct[i + 3][1] == 'E'
			return true			#  E-1 vs E+1 
		else
			#if ss_struct[i][1] == 'E' and ss_struct[i + 1][1] == 'E' and ss_struct[i + 2][1] == 'E' and ss_struct[i + 3][1] == 'E'
			#  return true			#  E vs E+1 == E-1 vs E
			#end
			return false			
		end
	      else					#     vs E+2
		if ss_struct[i + 1][1] != 'E' and ss_struct[i + 2][1] == 'E' and ss_struct[i + 3][1] == 'E'
			return true if (j - 2) - (i + 2) + 1 >= 5	# E-2 vs E+2
			return false
		else
			if ss_struct[i][1] != 'E' and ss_struct[i+1][1] == 'E' and ss_struct[i + 2][1] == 'E' and ss_struct[i + 3][1] == 'E' 
				return true if (j - 2) - (i + 1) + 1 >= 5 # ?	# E-1 vs E+2
				return false
			end
				
			#if ss_struct[i][1] == 'E' and ss_struct[i+1][1] == 'E' and ss_struct[i + 2][1] == 'E' and ss_struct[i + 3][1] == 'E' 
			#  return true			# E vs E+2 == E-2 vs E
			#end
			return false			
		end
	      end
	  end

	  # ss_struct[j - 1][1] == 'E' and ss_struct[j][1] == 'E'	#  vs E
	  if ss_struct[i][1] != 'E' or ss_struct[i+1][1] != 'E'  or ss_struct[i+2][1] != 'E' or ss_struct[i+3][1] != 'E'
	    if ss_struct[i+3][1] != 'E'					# E-4 vs E
	      return true if j - (i + 4) + 1  > 4
	      #return true if j - (i + 4) + 1  > 5				
	      return false
	    end
	    if ss_struct[i+2][1] != 'E' and ss_struct[i+3][1] == 'E'
	        return true						# E-3 vs E
	    end
	    if ss_struct[i+1][1] != 'E' and ss_struct[i+2][1] == 'E' and ss_struct[i+3][1] == 'E'
		return true						# E-2 vs E
	    end
	    if ss_struct[i][1] != 'E' and ss_struct[i+1][1] == 'E' and ss_struct[i+2][1] == 'E' and ss_struct[i+3][1] == 'E'
	      return true						# E-1 vs E
	    end
	    raise 'Error \n' #return false
	  else
	    return true							# E vs E
	  end

	end	# beta_clash?

   	def beta_clash?(ss_struct, i, j) 
	  if i > j
	    k = i
	    i = j
	    j = k
	  end
	  clash = beta_clash_0?(ss_struct[0], i, j) 
	  return clash if clash 
	  return beta_clash_0?(ss_struct[1], ss_struct[0].size - j, ss_struct[0].size - i)
	  #return false
	end


    $sec_struct_clash_pair = [] if ! defined?($sec_struct_clash_pair)

	if i > j
	  k = i
	  i = j
	  j = k
	end

	if ! $sec_struct_clash_pair.nil?
	  $sec_struct_clash_pair = [] if $sec_struct_clash_pair.nil?

	  if ! $sec_struct_clash_pair[i].nil?
		if ! $sec_struct_clash_pair[i][j].nil?
			return $sec_struct_clash_pair[i][j]
		end
	  end
	  if ! $sec_struct_clash_pair[j].nil?
		if ! $sec_struct_clash_pair[j][i].nil?
			return $sec_struct_clash_pair[j][i]
		end
	  end
	end
	
	if helix_clash?(ss_struct, i, j) 
	    if ! $sec_struct_clash_pair.nil?
		$sec_struct_clash_pair[i] = [] if $sec_struct_clash_pair[i].nil?
		$sec_struct_clash_pair[i][j] = 'a'
		$sec_struct_clash_pair[j] = [] if $sec_struct_clash_pair[j].nil?
		$sec_struct_clash_pair[j][i] = 'a'
  	    end
	    return 'a'
	else
	  if beta_clash?(ss_struct, i, j)
	    if ! $sec_struct_clash_pair.nil?
		$sec_struct_clash_pair[i] = [] if $sec_struct_clash_pair[i].nil?
		$sec_struct_clash_pair[i][j] = 'b'
		$sec_struct_clash_pair[j] = [] if $sec_struct_clash_pair[j].nil?
		$sec_struct_clash_pair[j][i] = 'b'
  	    end
	    return 'b'
	  end
	end
	if ! $sec_struct_clash_pair.nil?
		$sec_struct_clash_pair[i] = [] if $sec_struct_clash_pair[i].nil?
		$sec_struct_clash_pair[i][j] = false
		$sec_struct_clash_pair[j] = [] if $sec_struct_clash_pair[j].nil?
		$sec_struct_clash_pair[j][i] = false
	end
	return false
end

def	s_s_repartnering(i, j)

	if defined?($sec_struct)
		ss_struct = $sec_struct[0]
	else
		raise "Error: sec_struct is needed.\n"
	end

	if ss_struct[i][0] != 'C' or ss_struct[j][0] != 'C'
		return false, ss_struct
	end

	return true, ss_struct
end


##
