
# see assess_pc_score.rb

def output_residue_pair_info(port, residue_pair_info, n_characters = nil)

	printf port, "# residue serial#,  corr. coeff., minimum residual ratios, and partial corr. coeff. for each category, target category no., score, rank\n"
	printf port, "#	rank= -9 and 9999 are assigned to pairs excluded, and to pairs whose correlations are insignificant, respectively.\n"
	printf port, "#	Pairs with rank= 9998 or 9997 are regarded as anomalous sites.\n"


	residue_pair_info.each do |r1, v1|
		residue_pair_info[r1].each do |r2, v2|
			i_catg, pc , rank = residue_pair_info[r1][r2][-1]
			rank = 9999	if rank.nil?

			printf port, "%d %d", residue_pair_info[r1][r2][0][0], residue_pair_info[r1][r2][0][1]
			for i in [1, 2]
				printf port, "\t%d %d", residue_pair_info[r1][r2][i][0], residue_pair_info[r1][r2][i][1]
			end

			n_characters = residue_pair_info[r1][r2].size - 3 - 1 if n_characters.nil?

			j_catg = 0
			(0...n_characters).each do |i|
				#next if USE_CORRELATION[i] > 5 

				printf port, "\t%f", residue_pair_info[r1][r2][i + 3][0]
				(1...residue_pair_info[r1][r2][i + 3].size).each do |j|
					printf port, " %f", residue_pair_info[r1][r2][i + 3][j]
				end

				j_catg = j_catg + 1 if i < i_catg
			end
			#printf port, "\t%d %f %d\n", j_catg + 1, pc, rank
			printf port, "\t%d %f %d\n", j_catg, pc, rank
		end
	end
end

def get_rank(port)

	residue_pair_info = Hash.new
	threshold = nil
	ip = 0
        port.each_line("\n") do |line|
          line.chomp!
          if is_comment?(line, '^#')
		if threshold.nil?
			threshold = line[/threshold \|r\| from t-test[^:]*: *([0-9.]*  *[0-9.]*) *$/, 1]
			if ! threshold.nil?
				threshold = threshold.split(/  */)
				(0...threshold.size).each { |i| threshold[i] = threshold[i].to_f }
			end
		end
		next
	  end
	  #items = line.split(/ *, */)
	  items = line.split(/\t/)
	  (0..2).each do |i| 
		items[i] = items[i].split(/  */)
		(0...items[i].size).each {|j| items[i][j] = items[i][j].to_i }
	  end
	  pair = items[2]
	  r1 = pair[0]
	  r2 = pair[1]
	  pic = items[-1].split(/  */)
	  rank = pic[-1].to_i
	  pc = pic[-2].to_f
	  i_catg = pic[-3].to_i

	  n_catgs = (items.size - 3 - 1)
	  c_and_pc = []
	  (0...n_catgs).each do |i|
		c_and_pc[i] = items[i + 3].split(/  */)
		(0...c_and_pc[i].size).each { |j| c_and_pc[i][j] = c_and_pc[i][j].to_f }
	  end
	  residue_pair_info[r1] = Hash.new if residue_pair_info[r1].nil?
	  residue_pair_info[r1][r2] = [ items[0], items[1], pair, c_and_pc, [i_catg, pc, rank]]
	  #residue_pair_info[r2] = Hash.new if residue_pair_info[r2].nil?
	  #residue_pair_info[r2][r1] = residue_pair_info[r1][r2]
	  ip = ip + 1
        end 

	return residue_pair_info, threshold
end
