

   def pc_ranking(residue_pairs, residue_pair_score, lower_threshold, threshold, max_nc)

     residue_pair_score = residue_pair_score.sort { |x, y|  y[2].abs <=> x[2].abs }
	
     def choose_pair_of_rank_n(n, residue_pairs, n_contacts_at_each_site, residue_pair_score, lower_threshold, rank_pos)

       n_contacts_at_each_site = [] if n_contacts_at_each_site.nil?

       pair = -1
       (0...residue_pair_score.size).each do |i_pair|
		i, j, score, n_substitutions,  = residue_pair_score[i_pair]
		rank = residue_pair_score[i_pair][rank_pos]
		next if ! rank.nil?

		if ! pair_included?(residue_pairs, i, j) 
			#residue_pair_score[i_pair] = residue_pair_score[i_pair] + [ -9 ]
			residue_pair_score[i_pair][rank_pos] = -9
			next
		end

		#if ! residue_pair_mi_di[i].nil? and ! residue_pair_mi_di[i][j].nil? 
		#	if residue_pair_mi_di[i][j][0].is_a?(Array)
		#		if residue_pair_mi_di[i][j][0][3] > 0 #or residue_pair_mi_di[i][j][0][4] > 0 #or residue_pair_mi_di[i][j][0][5] > 0 
		#			residue_pair_score[i_pair] = [i, j, score, n_substitutions, -9]
		#			next 
		#		end
		#	end
		#end

		if defined?(SEC_STRUCT_CLASH_FLAG) and SEC_STRUCT_CLASH_FLAG
			if sec_struct_clash?(i, j)	
				residue_pair_score[i_pair][rank_pos] = 9980
				next
			end
		end
		if defined?(CYS_CYS_REPARTNERING_FLAG) and CYS_CYS_REPARTNERING_FLAG
			ss, ss_struct = s_s_repartnering(i, j)
			if ss
			  (0...residue_pair_score.size).each do |i_p|
				next if i_pair == i_p
				next if ! residue_pair_score[i_p][rank_pos].nil?
				ii, jj, = residue_pair_score[i_p]
				next if ii != i and jj != j
				next if ss_struct[ii][0] != 'C' or ss_struct[jj][0] != 'C'
				residue_pair_score[i_p][rank_pos] = 9970 
			  end
			end
		end

		next if score != n_substitutions and n_substitutions < lower_threshold[n]

		n_contacts_at_each_site[i] = 0	if n_contacts_at_each_site[i].nil?
		n_contacts_at_each_site[j] = 0	if n_contacts_at_each_site[j].nil?

		n_contacts_at_each_site[i] = n_contacts_at_each_site[i] + 1
		n_contacts_at_each_site[j] = n_contacts_at_each_site[j] + 1

		if n_contacts_at_each_site[i] > MAX_N_CONTACTS or n_contacts_at_each_site[j] > MAX_N_CONTACTS
			residue_pair_score[i_pair][rank_pos] = 9995
			next
		end

		residue_pair_score[i_pair][rank_pos] = n
		pair = i_pair
		n = n + 1

		break
       end
       return pair, residue_pair_score, n_contacts_at_each_site
     end

     n_contacts_at_each_site = []

     rank_pos = residue_pair_score[0].size

     (1..max_nc).each do |n|
	  i_pair, residue_pair_score, n_contacts_at_each_site = choose_pair_of_rank_n(n, residue_pairs,
				n_contacts_at_each_site, residue_pair_score, lower_threshold, rank_pos)
	  if i_pair < 0
		max_nc = n - 1
		break
	  end
     end

     max = [0, 0]
     (1..n_contacts_at_each_site.size).each do |i|
		next if n_contacts_at_each_site[i].nil?
		if n_contacts_at_each_site[i] > MAX_N_CONTACTS
		  printf "# For site %d, (%d - %d) contacts are ignored; indicated by the rank number 9995.\n", i, n_contacts_at_each_site[i], MAX_N_CONTACTS
		end
		max = [ n_contacts_at_each_site[i], i] if max[0] < n_contacts_at_each_site[i]
     end
     printf $stderr, "# Max no. contacts = %d at site %d for the total number of contacts %d .\n", max[0], max[1], max_nc

     return residue_pair_score

   end

   def pc_score(contact_pairs, residue_pair_score, threshold, nc_array)

     residue_pair_score_v = []
     rank_pos = 0
     (0...residue_pair_score.size).each do |i|
		rank_pos = residue_pair_score[i].size if residue_pair_score[i].size > rank_pos
		residue_pair_score_v[i] = residue_pair_score[i].dup
     end
     rank_pos = rank_pos - 1

     (0...residue_pair_score_v.size).each do |i|
	residue_pair_score_v[i][rank_pos] = 9999 if residue_pair_score_v[i][rank_pos].nil?
     end

     residue_pair_score_v = residue_pair_score_v.sort { |x, y|  x[rank_pos] <=> y[rank_pos] }

     scores = []
	# tp, fn, fp, tn, co-tp, co-fn, co-fp, co-tn, 
     (0...nc_array.size).each do |i|
	#scores[i] = [0, nil, 0, nil]
	scores[i] = [0, nil, 0, nil, 0, nil, 0, nil, 0.0, nil, nil]
     end
     min_dist_for_each_contact = nil
     i_nc = 0
     (0...residue_pair_score_v.size).each do |ip|
	n = residue_pair_score_v[ip][rank_pos]
	next if n.nil?
	next if n > nc_array[-1]
	next if n <= 0
	if ! threshold.nil? and residue_pair_score_v[ip][2].abs < threshold and scores[nc_array.size].nil?
	  #scores[nc_array.size] = [scores[i_nc][0], scores[i_nc][1], scores[i_nc][2], scores[i_nc][3]]
	  scores[nc_array.size] = scores[i_nc].dup
	  scores[nc_array.size][9] = scores[i_nc][9].dup	if ! scores[i_nc][9].nil?
	end

        if n > nc_array[i_nc]
	  scores[i_nc + 1] = scores[i_nc].dup
	  scores[i_nc + 1][9] = scores[i_nc][9].dup		if ! scores[i_nc][9].nil?
	  i_nc = i_nc + 1
	end
	  i = residue_pair_score_v[ip][0]
	  j = residue_pair_score_v[ip][1]
	  if pair_included?(contact_pairs, i, j)
		scores[i_nc][0] = scores[i_nc][0] + 1
		scores[i_nc][4] = scores[i_nc][4] + (i - j).abs
		scores[i_nc][8] =  scores[i_nc][8] + 
			distance_to_nearest_true_contact(i, j, contact_pairs)[0]
		scores[i_nc][9], min_dist_for_each_contact = 
			coverage_of_contact_map(scores[i_nc][9], min_dist_for_each_contact, i, j, contact_pairs)
	  else
		scores[i_nc][2] = scores[i_nc][2] + 1
		scores[i_nc][6] = scores[i_nc][6] + (i - j).abs
		scores[i_nc][8] =  scores[i_nc][8] + 
			distance_to_nearest_true_contact(i, j, contact_pairs)[0]
		scores[i_nc][9], min_dist_for_each_contact = 
			coverage_of_contact_map(scores[i_nc][9], min_dist_for_each_contact, i, j, contact_pairs)
	  end
	if n == nc_array[i_nc]
		scores[i_nc][-1] =  residue_pair_score_v[ip][2]
	end
	
     end

     return scores
   end

