#! /usr/local/bin/ruby 
#! /usr/local/bin/ruby -w

#require 'Bio'
require "Utils/is_comment.rb"
require "Utils/Utils.rb"
include Utils


FLAG_3D_AVAILABLE = true

CONTACT_DISTANCE = 5.0          # 5.0 A for minimum atomic distance between residues
CHEMICAL_BOND_THRESHOLD = 2.5   # 2.5 A for maximum chmical bond length
MAX_SEPARATION_ALONG_CHAIN_EXCLUDED = 5
#MAX_SEPARATION_ALONG_CHAIN_EXCLUDED = 3

#USE_AXES = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 0, 12, 13]
USE_AXES = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13]

# for get_discore.rb
FLAG_DI_SCORE = false

DI_SEC_STRUCT_CLASH_FLAG = false        #true
DI_HIGH_CONSERVATION_FLAG = true
DI_CYS_CYS_REPARTNERING_FLAG = false    #true

SEC_STRUCT_CLASH_FLAG = false   #true
CYS_CYS_REPARTNERING_FLAG = false #true


def main

    iarg = 2
    nc = nil
    nc = ARGV[iarg + 5].to_i if ! ARGV[iarg + 5].nil?
    port = $stdin

	if (ARGV[0] =~ /^.*no.*del.*pos.*$/).nil? 
	# positions in the MSA that are included in the calculation of partial correlation coefficients
		prtseq = File.open(ARGV[0], "r")
        	used_positions = get_positions(prtseq)
		seq = get_seq(prtseq)
	# If this seq is included in the seed alignment, all sites are reliable and written in upper case.
		used_region = []
		(0...seq.size).each do |i| 
			if seq[i] == seq[i].upcase
				used_region[i] = 1	
			end
		end
		min_res_num = 1
		max_res_num = seq.size

        	use_positions = nil
	else	
	# If del positions in the MSA are included in the calculation of partial correlation coefficients
	# non_del positions are needed.
		prtseq = File.open(ARGV[0], "r")
        	use_positions = get_positions(prtseq)
		seq = get_seq(prtseq)
		used_region = []
		(0...seq.size).each do |i| 
			if seq[i] == seq[i].upcase
				used_region[i] = 1	
			end
		end
		min_res_num = 1
		max_res_num = seq.size
       	end
   
    if FLAG_3D_AVAILABLE
      rpad = File.open(ARGV[iarg], "r")
    end

  if FLAG_DI_SCORE
    residue_position_map_txt=ARGV[iarg + 2]
    residue_position_map = File.open(residue_position_map_txt, "r")

    res_num_from = get_res_num_from(residue_position_map)
    eic = File.open(ARGV[iarg + 1], "r")
    mi_di =  File.open(ARGV[iarg + 3], "r")

    port_ss_pred =  File.open(ARGV[iarg + 4], "r")		if DI_SEC_STRUCT_CLASH_FLAG or SEC_STRUCT_CLASH_FLAG
  end

    if FLAG_3D_AVAILABLE
      residue_pair_distance, min_res_num, max_res_num, = get_rpad(rpad)
    else
	residue_pair_distance = nil
	#min_res_num, max_res_num, =
    end

    ss_predicted = get_ss_pred(port_ss_pred, res_num_from)	if DI_SEC_STRUCT_CLASH_FLAG or SEC_STRUCT_CLASH_FLAG

   ##
  if FLAG_DI_SCORE
    used_region, residue_pair_mi_di, = get_discore(eic, res_num_from)
    sec_struct_clash?(1, 1, ss_predicted, residue_pair_mi_di)
    used_region, = get_mi_di(mi_di, res_num_from)
  else
    residue_pair_mi_di = nil
    used_region = []
    (1..(max_res_num - min_res_num + 1)).each { |i| used_region[i] = 1 }
  end
   ##

   #if FLAG_3D_AVAILABLE
    n_residue_pairs, n_bonds, n_contacts, residue_pairs, bonded_residue_pairs, contact_pairs, contact_order =
        contact_residue_pairs(used_region, residue_pair_distance, CONTACT_DISTANCE, min_res_num, max_res_num, residue_pair_mi_di)
   #end

   ##
    residue_pair_info, threshold = get_rank(port)

    residue_pair = []
    residue_pair_info.each do |i, iv|
    #	next if residue_pair_info[i].nil?
    	residue_pair_info[i].each do |j, jv|
    #		next if residue_pair_info[i][j].nil?
		pair = [ i, j ] + residue_pair_info[i][j]
		residue_pair = residue_pair + [ pair ]
	end
    end
   
    residue_pair = residue_pair.sort { |x, y|  x[-1][-1] <=> y[-1][-1] }

    n = 0
    (0...residue_pair.size).each do |ip|
		i = residue_pair[ip][0]
		j = residue_pair[ip][1]
		next if residue_pair[ip][-1][-1] < 0
		next if ! pair_included?(residue_pairs, i, j)
		n = n + 1
		if nc.nil?
			break if residue_pair[ip][-1][-2].abs < threshold[-1]
		else
			break if n > nc
		end
                printf "%d %d", i, j
                if pair_included?(contact_pairs, i, j)
			if contact_pairs.nil?
                        	printf "\tTP\tassumed\n"
			elsif ! contact_pairs[i].nil? and ! contact_pairs[i][j].nil?
                        	printf "\tTP\t%f\n", contact_pairs[i][j]
			else
                        	printf "\tTP\n"
			end
                else
			if contact_pairs.nil?
                        	printf "\tFP\tassumed\n"
			elsif ! contact_pairs[i].nil? and ! contact_pairs[i][j].nil?
                        	printf "\tFP\t%f\n", contact_pairs[i][j]
			else
                        	printf "\tFP\n"
			end
                end
    end
 
end #def main

require "get_rpad.rb"
require "contact_residue_pairs.rb"
require "get_discore.rb"		if FLAG_DI_SCORE
require "get_pc.rb"
require "output_residue_pair_info.rb"

main
