#! /usr/local/bin/ruby 
#! /usr/local/bin/ruby -w

#require 'Bio'
require "Utils/is_comment.rb"
require "Utils/Utils.rb"
include Utils


FLAG_3D_AVAILABLE = false

CONTACT_DISTANCE = 5.0		# 5.0 A for minimum atomic distance between residues
CHEMICAL_BOND_THRESHOLD = 2.5	# 2.5 A for maximum chmical bond length
MAX_SEPARATION_ALONG_CHAIN_EXCLUDED = 5
#MAX_SEPARATION_ALONG_CHAIN_EXCLUDED = 3

#USE_AXES = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 0, 12, 13]
USE_AXES = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13]

# for get_discore.rb
FLAG_DI_SCORE = false

DI_SEC_STRUCT_CLASH_FLAG = false 
DI_HIGH_CONSERVATION_FLAG = true
DI_CYS_CYS_REPARTNERING_FLAG = false    #true

SEC_STRUCT_CLASH_FLAG = false 
CYS_CYS_REPARTNERING_FLAG = false #true


def main

    opt = ''

    while true do
	i = 0;
	if ARGV[i] =~ /^--di/ then
		opt = opt + ARGV[i]
		ARGV.shift
	else
		break
	end
    end

	if (ARGV[0] =~ /^.*no.*del.*pos.*$/).nil? 
	# positions in the MSA that are included in the calculation of partial correlation coefficients
		prtseq = File.open(ARGV[0], "r")
        	used_positions = get_positions(prtseq)
		seq = get_seq(prtseq)
	# If this seq is included in the seed alignment, all sites are reliable and written in upper case.
		used_region = []
		(0...seq.size).each do |i| 
			if seq[i] == seq[i].upcase
				used_region[i] = 1	
			end
		end
		min_res_num = 1
		max_res_num = seq.size

        	use_positions = nil
	else	
	# If del positions in the MSA are included in the calculation of partial correlation coefficients
	# non_del positions are needed.
		prtseq = File.open(ARGV[0], "r")
        	use_positions = get_positions(prtseq)
		seq = get_seq(prtseq)
		used_region = []
		(0...seq.size).each do |i| 
			if seq[i] == seq[i].upcase
				used_region[i] = 1	
			end
		end
		min_res_num = 1
		max_res_num = seq.size
       	end

    pic = File.open(ARGV[1], "r") 

    if FLAG_3D_AVAILABLE
     rpad = File.open(ARGV[2], "r")
    end

      if FLAG_DI_SCORE
        eic = File.open(ARGV[3], "r")

	residue_position_map_txt=ARGV[4]

	#residue_position_map_txt="Residue_position_map.txt"
	#if ARGV[2] =~ /\//
	#  residue_position_map_txt=ARG[2](/^(.*)\/[\/]*$/,\1) + "Residue_position_map.txt"
	#  residue_position_map = 
	#else
	  residue_position_map = File.open(residue_position_map_txt, "r")
	#end
	res_num_from = get_res_num_from(residue_position_map)

        mi_di = File.open(ARGV[5], "r")

	port_ss_pred =  File.open(ARGV[6], "r") if DI_SEC_STRUCT_CLASH_FLAG or SEC_STRUCT_CLASH_FLAG
      end

    if FLAG_3D_AVAILABLE
    	residue_pair_distance, min_res_num, max_res_num, = get_rpad(rpad)
    else
    	residue_pair_distance = nil
	#min_res_num = 1
	#max_res_num = 
    end

    ss_predicted = get_ss_pred(port_ss_pred, res_num_from) if DI_SEC_STRUCT_CLASH_FLAG or SEC_STRUCT_CLASH_FLAG

  if FLAG_DI_SCORE
    if opt == '--di'
      used_region, residue_pair_mi_di, = get_mi_di(eic, res_num_from)
    else
      used_region, residue_pair_mi_di, = get_discore(eic, res_num_from)
      #used_region, residue_pair_mi_di, = get_discore_with_filter_check(eic, res_num_from, ss_predicted)
      sec_struct_clash?(1, 1, ss_predicted, residue_pair_mi_di) if DI_SEC_STRUCT_CLASH_FLAG or SEC_STRUCT_CLASH_FLAG
      used_region, = get_mi_di(mi_di, res_num_from)
    end

    raise "Sequence Region is wrong.\n"         if used_region.size > (max_res_num - min_res_num + 2)
  else
    residue_pair_mi_di = nil
    #used_region = []
    #(1..(max_res_num - min_res_num + 1)).each { |i| used_region[i] = 1 }
  end

    #n_residue_pairs = (max_res_num - min_res_num + 1) * (max_res_num - min_res_num) / 2

    printf "# Neighboring residue pairs (|i - j| <= %d) are excluded.\n", MAX_SEPARATION_ALONG_CHAIN_EXCLUDED

    #if FLAG_3D_AVAILABLE
      n_residue_pairs, n_bonds, n_contacts, residue_pairs, bonded_residue_pairs, contact_pairs, contact_order =
        contact_residue_pairs(used_region, residue_pair_distance, CONTACT_DISTANCE, min_res_num, max_res_num, residue_pair_mi_di)
    #end

    #n_residues = (max_res_num - min_res_num + 1)
    n_residues = 0
    (1...used_region.size).each { |i| n_residues = n_residues + 1 if ! used_region[i].nil? }

    nc_array = []
    #min_nc = (n_residues * 0.5).to_i
    min_nc = (n_contacts * 0.25).to_i
    #max_nc = n_residues
    #max_nc = (n_residues * 0.75).to_i
    max_nc = (n_contacts / 3.0).to_i
    max_n_predicts = n_residues * 3.0
    max_nc = max_n_predicts		if ! FLAG_3D_AVAILABLE
    nc = 10
    i = 0
    #while nc <= n_residues * 1.0 or nc <= 50 do
    #while nc <= max_nc or nc <= 50 do
    while nc <= [max_nc, max_n_predicts].max
      nc_array[i] = nc
      i = i + 1
      if nc < min_nc and nc + 10 > min_nc
        nc_array[i] = min_nc
        i = i + 1
      end
      if nc < max_nc and nc + 10 > max_nc
        nc_array[i] = max_nc
        i = i + 1
      end
      if nc < n_residues and nc + 10 > n_residues
	if max_nc != n_residues
          nc_array[i] = n_residues
          i = i + 1
	end
      end
      if nc < max_n_predicts and nc + 10 > max_n_predicts
	if max_nc != max_n_predicts && n_residues != max_n_predicts
          nc_array[i] = max_n_predicts
          i = i + 1
	end
      end
      nc = nc + 10
    end

    if FLAG_3D_AVAILABLE
      printf "# #residues = %d  #residue_pairs = %d  #predicted = %d  #contacts = %d\n", n_residues, n_residue_pairs, max_n_predicts, n_contacts
    else
      printf "# #residues = %d  #residue_pairs = %d  #predicted = %d\n", n_residues, n_residue_pairs, max_n_predicts
    end

   first_block = true

   n_otu, threshold, n_characters, residue_pair_c, residue_pair_info, change_sd = get_pc(pic, n_residue_pairs, use_positions, inc_order_of_ev = true)

   #break if threshold.nil? 

   n_br = 2 * n_otu - 3                if ! n_otu.nil?

   if ! first_block 
     use_axes = USE_AXES
     printf "#axes used = " 
     p use_axes
   else
     use_axes = nil
   end

   lower_threshold, decreasing_order_of_n_subst_pc = calc_lower_threshold_array(residue_pairs, residue_pair_c, PRIORITY_CATG, n_residues, nc_array[-1])

   residue_pair_c_orig = residue_pair_c
   change_sd_threshold = (1.0 / Math.sqrt(n_br)) * 0.1             if ! n_otu.nil?

   residue_pair_c = filter_pc(residue_pair_c, PRIORITY_CATG, threshold, 0.0, change_sd, change_sd_threshold, residue_pairs, ! first_block)

   pic_scores =
      assess_pc_score(residue_pair_c, nc_array, PRIORITY_CATG, lower_threshold, threshold, residue_pairs, contact_pairs, n_residues, use_axes)

   ii = 0
   (0...USE_CORRELATION.size).each do |i|
	ii = i if USE_CORRELATION[i] != 9
   end
   i_method = ii
   printf "# method = %d\n", i_method

   residue_pair_info = combine(residue_pair_info, residue_pair_c, pic_scores[i_method][1])

   printf $stdout, "# residual ratio > %e for ranking\n", change_sd_threshold	if ! change_sd_threshold.nil?

   output_residue_pair_info($stdout, residue_pair_info)

end #def main

require "get_rpad.rb"		if FLAG_3D_AVAILABLE
require "contact_residue_pairs.rb"
require "get_discore.rb"	if FLAG_DI_SCORE
require "get_pc.rb"
require "pc_ranking.rb"

require "output_residue_pair_info.rb"
require "assess_pc_score.rb"

main
